package Cannon;

import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.geom.Point2D;
import java.net.MalformedURLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.*;
import javax.sound.sampled.*;
import javax.swing.*;
import java.net.URL;
import java.util.ArrayList;
import java.util.Scanner;
import javax.imageio.ImageIO;
import javax.sound.sampled.AudioInputStream;
//Handles the entire Game portion, including Shop, firing, etc.
class PnlPlay extends JPanel {

    private ArrayList<World> arcWorld = new ArrayList<World>();
    private ArrayList<String> arsLaunches = new ArrayList<String>();
    private ArrayList<String> arsExplosions = new ArrayList<String>();
    private Timer timeBall, timeExplode;
    private PnlPlayDrawMovements pnlDrawMovements = new PnlPlayDrawMovements();
    private PnlPlayButtons pnlPlayButtons = new PnlPlayButtons();
    private PnlPlayShop pnlPlayShop = new PnlPlayShop();
    private PlotProjectile plotProjectile = new PlotProjectile();
    private boolean isGoomba = false, isSpike = false, isStar = false;
    private int nScore = 0, nCurrentBoss;

    public PnlPlay() {
        this.setVisible(true);
//        Dimension dimSize = new Dimension();
//        dimSize.setSize(900, 600);
//        this.setPreferredSize(dimSize);
        this.setSize(900, 600);
        BorderLayout layout = new BorderLayout();
        layout.setVgap(0);
        layout.setHgap(0);
        this.setLayout(layout);
        this.add(pnlPlayShop);
        pnlPlayShop.setVisible(false);
        this.add(pnlDrawMovements, layout.CENTER);
        this.add(pnlPlayButtons, layout.SOUTH);
        pnlDrawMovements.addMouseMotionListener(new ActMouseMovement());
        pnlDrawMovements.addMouseListener(new ActMouseAction());
        pnlPlayButtons.btnFire.addActionListener(new ActFireButton());
        pnlPlayButtons.sliGunpowder.addChangeListener(new ActGunpowderSlider());
        pnlPlayButtons.sliAngle.addChangeListener(new ActAngleSlider());
        pnlPlayButtons.btnShop.addActionListener(new ActShopButton());
        pnlPlayShop.pnlShopBuy.btnBuyGoomba.addActionListener(new ActBuyGoomba());
        pnlPlayShop.pnlShopBuy.btnBuySpike.addActionListener(new ActBuySpike());
        pnlPlayShop.pnlShopBuy.btnBuyStar.addActionListener(new ActBuyStar());
        pnlPlayShop.pnlShopReturn.btnBack.addActionListener(new ActBackToGameButton());
        pnlPlayButtons.AddBulletButton(new ActBulletButton("bulletbill.png", new ImageIcon("bulletbill.png"), 100));
        pnlPlayButtons.updateStats(pnlPlayShop.getMoney(), pnlPlayShop.getPowder(), plotProjectile.getWind(), plotProjectile.getGravity());

        loadWorlds();

    }

    public void playSoundFile(final File file) {//http://java.ittoolbox.com/groups/technical-functional/java-l/sound-in-an-application-90681
        new Thread(//http://stackoverflow.com/questions/4708254/how-to-play-audio-in-java-application
                new Runnable() {

            public void run() {

                try {
//get an AudioInputStream
                    AudioInputStream ais = AudioSystem.getAudioInputStream(file);
//get the AudioFormat for the AudioInputStream
                    AudioFormat audioformat = ais.getFormat();

//ULAW format to PCM format conversion
                    if ((audioformat.getEncoding() == AudioFormat.Encoding.ULAW)
                            || (audioformat.getEncoding() == AudioFormat.Encoding.ALAW)) {
                        AudioFormat newformat = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED,
                                audioformat.getSampleRate(),
                                audioformat.getSampleSizeInBits() * 2,
                                audioformat.getChannels(),
                                audioformat.getFrameSize() * 2,
                                audioformat.getFrameRate(), true);
                        ais = AudioSystem.getAudioInputStream(newformat, ais);
                        audioformat = newformat;
                    }

//checking for a supported output line
                    DataLine.Info datalineinfo = new DataLine.Info(SourceDataLine.class, audioformat);
                    if (!AudioSystem.isLineSupported(datalineinfo)) {
                        //System.out.println("Line matching " + datalineinfo + " is not supported.");
                    } else {
                        //System.out.println("Line matching " + datalineinfo + " is supported.");
//opening the sound output line
                        SourceDataLine sourcedataline = (SourceDataLine) AudioSystem.getLine(datalineinfo);
                        sourcedataline.open(audioformat);
                        sourcedataline.start();
//Copy data from the input stream to the output data line
                        int framesizeinbytes = audioformat.getFrameSize();
                        int bufferlengthinframes = sourcedataline.getBufferSize() / 8;
                        int bufferlengthinbytes = bufferlengthinframes * framesizeinbytes;
                        byte[] sounddata = new byte[bufferlengthinbytes];
                        int numberofbytesread = 0;
                        while ((numberofbytesread = ais.read(sounddata)) != -1) {
                            int numberofbytesremaining = numberofbytesread;
                            sourcedataline.write(sounddata, 0, numberofbytesread);
                        }
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }).start();

    }

    //Abstract Action used for adding buttons to MenuBar
    public class ActBulletButton extends AbstractAction { //CoreJava8 Menubar Code (Heavily Modified)

        int nPower;

        public ActBulletButton(String sFile, Icon icon, int _nPower) {
            putValue(Action.NAME, sFile);
            putValue(Action.SMALL_ICON, icon);
            putValue("File", sFile);
            nPower = _nPower;
            putValue(Action.SHORT_DESCRIPTION, sFile);
            //putValue("Color", c);
        }

        public void actionPerformed(ActionEvent event) {
            if (!pnlDrawMovements.isFired() && !pnlDrawMovements.isExploded()) {
                String sLocation = (String) getValue("File");
                System.out.println(sLocation);
                Projectile projectile = new Projectile(sLocation);
                projectile.setPower(nPower);
                pnlDrawMovements.setProjectile(projectile);
                //pnlPlayButtons.pnlBullets.setBackground(c);
            }
        }
    }
    //the ActBuy... classes allow the purchase of the games various projectiles

    public class ActBuyGoomba implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            if (!isGoomba) {
                if (pnlPlayShop.getMoney() > pnlPlayShop.getGoombaPrice()) {
                    pnlPlayShop.removeMoney(pnlPlayShop.getGoombaPrice());
                    isGoomba = true;
                    pnlPlayButtons.AddBulletButton(new ActBulletButton("goomba.png", new ImageIcon("goomba.png"), 200));
                    pnlPlayShop.setResponse("Goomba successfully unlocked");
                } else {
                    pnlPlayShop.setResponse("Not enough money");
                }
            } else {
                pnlPlayShop.setResponse("You already unlocked the goomba");
            }
        }
    }

    public class ActBuySpike implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            if (!isSpike) {
                if (pnlPlayShop.getMoney() > pnlPlayShop.getSpikePrice()) {
                    pnlPlayShop.removeMoney(pnlPlayShop.getSpikePrice());
                    isSpike = true;
                    pnlPlayButtons.AddBulletButton(new ActBulletButton("spike.png", new ImageIcon("spike.png"), 400));
                    pnlPlayShop.setResponse("Spike shell successfully unlocked");
                } else {
                    pnlPlayShop.setResponse("Not enough money");
                }
            } else {
                pnlPlayShop.setResponse("You already unlocked the spike shell");
            }
        }
    }

    public class ActBuyStar implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            if (!isStar) {
                if (pnlPlayShop.getMoney() > pnlPlayShop.getStarPrice()) {
                    pnlPlayShop.removeMoney(pnlPlayShop.getStarPrice());
                    isStar = true;
                    pnlPlayButtons.AddBulletButton(new ActBulletButton("star.gif", new ImageIcon("star.gif"), 1000));
                    pnlPlayShop.setResponse("Star successfully unlocked");
                } else {
                    pnlPlayShop.setResponse("Not enough money");
                }
            } else {
                pnlPlayShop.setResponse("You already unlocked the star of death");
            }
        }
    }
    // The heart and soul of the game, this method makes everything that could be considered "playing" happen

    public class ActFireButton implements ActionListener {

        double dTime = 0;

        public void actionPerformed(ActionEvent e) {
            if (!pnlDrawMovements.isFired()) {
                if (!pnlDrawMovements.isExploded()) {
                    if (plotProjectile.getVelocity() < pnlPlayShop.getPowder()) {
                        if (arsLaunches.size() > 0) {
                            int nRand = (int) (Math.random() * arsLaunches.size());
                            playSoundFile(new File(arsLaunches.get(nRand)));
                        }
                        pnlPlayShop.removePowder((int) plotProjectile.getVelocity());
                        pnlPlayButtons.updateStats(pnlPlayShop.getMoney(), pnlPlayShop.getPowder(), plotProjectile.getWind(), plotProjectile.getGravity());
                        dTime = 0;
                        pnlDrawMovements.addCannonBall();
                        plotProjectile.setAngle(pnlDrawMovements.getCannonAngle());



                        AbstractAction updateLocation = new AbstractAction() {

                            public void actionPerformed(ActionEvent e) {
                                dTime += 0.04;
                                pnlPlayButtons.sliGunpowder.setEnabled(false);
                                Point2D ptBall = plotProjectile.getLocation(dTime);
                                ptBall.setLocation(ptBall.getX() * 5, ptBall.getY() * 5);
                                pnlDrawMovements.setBallLocation(ptBall);
                                int nBallLeadingX, nBallLeadingY;
                                nBallLeadingX = (int) (ptBall.getX() + pnlDrawMovements.getCannonX() + pnlDrawMovements.getProjectileWidth());
                                nBallLeadingY = (int) (0 - ptBall.getY() + pnlDrawMovements.getCannonY() + pnlDrawMovements.getProjectileHeight() / 2);
                                for (int i = 0; i < pnlDrawMovements.getBossQuan(); i++) {
                                    nCurrentBoss = i;
                                    if (pnlDrawMovements.isBossAlive(i)) {
                                        if (nBallLeadingX < pnlDrawMovements.getBossX(i) + pnlDrawMovements.getBossWidth(i) && nBallLeadingX > pnlDrawMovements.getBossX(i)) {
                                            if (nBallLeadingY < pnlDrawMovements.getBossY(i) + pnlDrawMovements.getBossHeight(i) && nBallLeadingY > pnlDrawMovements.getBossY(i)) {
                                                if (arsExplosions.size() > 0) {
                                                    int nRand = (int) (Math.random() * arsExplosions.size());
                                                    playSoundFile(new File(arsExplosions.get(nRand)));
                                                }
                                                pnlDrawMovements.setExploded(true);
                                                pnlDrawMovements.setFired(false);

                                                AbstractAction updateExplosion = new AbstractAction() {

                                                    public void actionPerformed(ActionEvent e) {

                                                        pnlDrawMovements.setExploded(false);
                                                        timeExplode.stop();
                                                    }
                                                };
                                                timeExplode = new Timer(500, updateExplosion);
                                                timeExplode.start();
                                                if (pnlDrawMovements.getBossHealth(nCurrentBoss) > pnlDrawMovements.getProjectilePower()) {
                                                    pnlDrawMovements.removeBossHealth(pnlDrawMovements.getProjectilePower(), nCurrentBoss);
                                                } else {
                                                    pnlDrawMovements.setBossAlive(false, nCurrentBoss);
                                                    nScore += pnlDrawMovements.getBossPoints(nCurrentBoss);
                                                    pnlDrawMovements.setScore(nScore);
                                                    if (!pnlDrawMovements.isAnyBossAlive()) {
                                                        levelUp();
                                                    }
                                                }
                                                pnlPlayShop.addMoney(100);
                                                pnlPlayButtons.updateStats(pnlPlayShop.getMoney(), pnlPlayShop.getPowder(), plotProjectile.getWind(), plotProjectile.getGravity());


                                            }
                                        }
                                    }
                                }
                                if (!pnlDrawMovements.isFired()) {
                                    timeBall.stop();
                                    plotProjectile.randomizeWind();
                                    pnlPlayButtons.updateStats(pnlPlayShop.getMoney(), pnlPlayShop.getPowder(), plotProjectile.getWind(), plotProjectile.getGravity());
                                    pnlPlayButtons.sliGunpowder.setEnabled(true);
                                }
                            }
                        };
                        timeBall = new Timer(20, updateLocation);
                        timeBall.start();
                    } else if (pnlPlayShop.getPowder() == 0) {
                        System.out.println("Out of Powder");
                    } else {
                        System.out.println("Not Enough Powder");
                    }
                }
            }
        }
    }
    //Handles slider event

    class ActAngleSlider implements ChangeListener {

        public void stateChanged(ChangeEvent e) {

            JSlider source = (JSlider) e.getSource();
            double dAngle = (double) source.getValue();
            pnlDrawMovements.setCannonAngle(Math.toRadians(dAngle));
            Point2D ptCannon = pnlDrawMovements.getCannonLocation();
            pnlDrawMovements.repaint((int) ptCannon.getX() - 55, (int) ptCannon.getY() - 55, 110, 110);
        }
    }
    //Switches from shop to game

    class ActBackToGameButton implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            pnlPlayShop.setVisible(false);
            pnlPlayButtons.setVisible(true);
            pnlDrawMovements.setVisible(true);
            pnlPlayButtons.updateStats(pnlPlayShop.getMoney(), pnlPlayShop.getPowder(), plotProjectile.getWind(), plotProjectile.getGravity());

        }
    }
    //Handles slider event

    class ActGunpowderSlider implements ChangeListener {

        public void stateChanged(ChangeEvent e) {
            JSlider source = (JSlider) e.getSource();
            double dVelocity = (double) source.getValue();
            plotProjectile.setVelocity(dVelocity);
        }
    }
    //Moves cannon based on mouse

    public class ActMouseMovement implements MouseMotionListener {

        public void mouseDragged(MouseEvent e) {
            double dBase, dHeight, dAngle;
            Point2D ptCannonLocation = pnlDrawMovements.getCannonLocation();
            dBase = e.getX() - ptCannonLocation.getX();
            dHeight = ptCannonLocation.getY() - 5 - e.getY() + 10;
            dAngle = Math.atan2(dHeight, dBase);
            pnlDrawMovements.setCannonAngle(dAngle);
            Point2D ptCannon = pnlDrawMovements.getCannonLocation();
            pnlDrawMovements.repaint((int) ptCannon.getX() - 55, (int) ptCannon.getY() - 55, 110, 110);
            pnlPlayButtons.setAngleSlider((int) Math.toDegrees(dAngle));
        }//http://download.oracle.com/javase/tutorial/uiswing/examples/events/MouseMotionEventDemoProject/src/events/MouseMotionEventDemo.java

        public void mouseMoved(MouseEvent e) {
        }
    }
    //Moves cannon based on mouse

    public class ActMouseAction implements MouseListener {

        public void mousePressed(MouseEvent e) {
            double dBase, dHeight, dAngle;
            Point2D ptCannonLocation = pnlDrawMovements.getCannonLocation();
            dBase = e.getX() - ptCannonLocation.getX();
            dHeight = ptCannonLocation.getY() - 5 - e.getY() + 10;
            dAngle = Math.atan2(dHeight, dBase);
            pnlDrawMovements.setCannonAngle(dAngle);
            Point2D ptCannon = pnlDrawMovements.getCannonLocation();
            pnlDrawMovements.repaint((int) ptCannon.getX() - 55, (int) ptCannon.getY() - 55, 110, 110);
            pnlPlayButtons.setAngleSlider((int) Math.toDegrees(dAngle));
        }

        public void mouseReleased(MouseEvent e) {
        }

        public void mouseEntered(MouseEvent e) {
        }

        public void mouseExited(MouseEvent e) {
        }

        public void mouseClicked(MouseEvent e) {
        } // From http://www.rgagnon.com/javadetails/java-0236.html
    }
    //Opens Shop

    class ActShopButton implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            pnlPlayShop.setVisible(true);
            pnlPlayButtons.setVisible(false);
            pnlDrawMovements.setVisible(false);

        }
    }

    public void addWorld(File _fileWorld) {
        addWorld(_fileWorld.getAbsolutePath());
    }

    public void addWorld(String _sFile) {



        boolean isUnique = true;
        System.out.println(_sFile + " has made it to pnlPlay");
        for (int i = 0; i < arcWorld.size(); i++) {
            if (_sFile.equalsIgnoreCase(arcWorld.get(i).getPath())) {
                isUnique = false;
            }
        }

        if (isUnique) {
            System.out.println(_sFile + " is the first of its kind");
            try {
                PrintWriter fout = new PrintWriter(new FileWriter("worlds.txt"));
                Scanner fin = new Scanner(new FileReader(_sFile));
                String sImgBG, sImgBoss, sImgMario, sTrash, sName;
                int nBossX, nBossY, nBossHP, nBossPts, nWindVarience, nMarioX, nMarioY;
                double dGravity;
                World world;
                ArrayList<Boss> arcBoss = new ArrayList<Boss>();
                sTrash = fin.next();
                sName = fin.next();
                sTrash = fin.next();
                sImgBG = fin.next();
                while (true) {
                    sTrash = fin.next();
                    if (sTrash.equalsIgnoreCase("BossImage:")) {

                        sImgBoss = fin.next();
                        System.out.println("Boss " + sImgBoss + " Discovered");
                        sTrash = fin.next();
                        nBossX = fin.nextInt();
                        sTrash = fin.next();
                        nBossY = fin.nextInt();
                        arcBoss.add(new Boss(sImgBoss, 1000, 1000, nBossX, nBossY));

                    } else if (sTrash.equalsIgnoreCase("LaunchSound:")) {

                        arsLaunches.add(fin.next());
                        System.out.println("Launch Sound Aded");

                    } else if (sTrash.equalsIgnoreCase("ExplodeSound:")) {
                        arsExplosions.add(fin.next());
                        System.out.println("Explode Sound Aded");
                    } else {
                        break;
                    }
                }
                //sTrash = fin.next();
                dGravity = fin.nextDouble();
                sTrash = fin.next();
                nWindVarience = fin.nextInt();
                BufferedImage buffImgBG = ImageIO.read(new File(sImgBG));
                sTrash = fin.next();
                sImgMario = fin.next();
                sTrash = fin.next();
                nMarioX = fin.nextInt();
                sTrash = fin.next();
                nMarioY = fin.nextInt();
                Mario mario = new Mario(sImgMario, nMarioX, nMarioY);
                world = new World(arcBoss, buffImgBG, dGravity, nWindVarience, _sFile, mario);
                arcWorld.add(world);
                for (int i = 0; i < arcWorld.size(); i++) {
                    fout.println(arcWorld.get(i).getPath());
                }
                fout.close();
                System.out.println(world.getPath() + " loaded");
                //pnlPlay.setEnvironment(sFileBG, sFileBoss,nBossX,nBossY, nBossHP, nBossPts, dGravity, nWindVarience);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

    }

    public int getScore() {
        return nScore;
    }

    public void levelUp() {
        pnlPlayShop.setVisible(true);
        pnlPlayButtons.setVisible(false);
        pnlDrawMovements.setVisible(false);
        pnlDrawMovements.addLevel();
        int nWorld, nCurrentHP, nCurrentPts;
        pnlDrawMovements.setLevelHealth(pnlDrawMovements.getLevelHealth() + 1000);
        pnlDrawMovements.setLevelPoints(pnlDrawMovements.getLevelPoints() + 1000);
        System.out.println(arcWorld.size());
        nWorld = (int) (Math.random() * arcWorld.size());
        System.out.println(nWorld);
        selectWorld(nWorld);
        for (int i = 0; i < pnlDrawMovements.getBossQuan(); i++) {
            pnlDrawMovements.setBossPoints(pnlDrawMovements.getLevelPoints() / pnlDrawMovements.getBossQuan(), i);
            pnlDrawMovements.setBossHealth(pnlDrawMovements.getLevelHealth() / pnlDrawMovements.getBossQuan(), i);
            pnlDrawMovements.setBossAlive(true, i);
        }
    }

    public void loadWorlds() {
        try {
            //File fileWorlds = new File("worlds.txt");
            System.out.println("Loading Worlds");
            if (new File("worlds.txt").exists()) {
                System.out.println("worlds.txt exists");
                Scanner fin = new Scanner(new FileReader("worlds.txt"));
                arcWorld.clear();
                System.out.println("arcWorld cleared");
                if (fin.hasNext()) {
                    addWorld(fin.next());
                    while (fin.hasNext()) {
                        addWorld(fin.next());
                        System.out.println("Multiple env detected");
                    }
                    selectWorld(0);
                } else {
                    addWorld("mushroomkingdom.env");
                    selectWorld(0);
                }
            } else {
                addWorld("mushroomkingdom.env");
                selectWorld(0);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void resetGame() {
        nScore = 0;
        pnlDrawMovements.setScore(nScore);
        isGoomba = false;
        isStar = false;
        isSpike = false;
        pnlDrawMovements.setVisible(true);
        pnlDrawMovements.setLevel(1);
        pnlPlayButtons.setVisible(true);
        pnlPlayShop.setVisible(false);
        pnlPlayShop.setPowder(1000);
        pnlPlayShop.setMoney(100000);
        pnlDrawMovements.setFired(false);
        pnlDrawMovements.setExploded(false);
        pnlDrawMovements.setCannonAngle(0);
        pnlDrawMovements.resetProjectile();
        pnlPlayButtons.barBullets.removeAll();
        pnlPlayButtons.AddBulletButton(new ActBulletButton("bulletbill.png", new ImageIcon("bulletbill.png"), 0));
        pnlPlayButtons.updateStats(pnlPlayShop.getMoney(), pnlPlayShop.getPowder(), plotProjectile.getWind(), plotProjectile.getGravity());
    }

    public void setMenuButtonListener(ActionListener actMenu) {
        pnlPlayButtons.btnMenu.addActionListener(actMenu);
        pnlPlayShop.pnlShopReturn.btnMainMenu.addActionListener(actMenu);
    }

    public void selectWorld(World _world) {
        System.out.println("selectWorld called, setting first boss");
        pnlDrawMovements.setBoss(_world.getBoss(0));
        pnlDrawMovements.setBossPoints(pnlDrawMovements.getLevelPoints() / pnlDrawMovements.getBossQuan(), 0);
        pnlDrawMovements.setBossHealth(pnlDrawMovements.getLevelHealth() / pnlDrawMovements.getBossQuan(), 0);
        pnlDrawMovements.setBossAlive(true, 0);
        pnlDrawMovements.setMario(_world.getMario());
        for (int i = 1; i < _world.getBossQuan(); i++) {
            System.out.println("Adding " + i + 1 + " boss");
            pnlDrawMovements.addBoss(_world.getBoss(i));

            pnlDrawMovements.setBossPoints(pnlDrawMovements.getLevelPoints() / pnlDrawMovements.getBossQuan(), i);
            pnlDrawMovements.setBossHealth(pnlDrawMovements.getLevelHealth() / pnlDrawMovements.getBossQuan(), i);
            pnlDrawMovements.setBossAlive(true, i);
        }
        pnlDrawMovements.setBackground(_world.getBackground());
        plotProjectile.setGravity(_world.getGravity());
        plotProjectile.setWindVariance(_world.getWind());
    }

    public void selectWorld(int _nIndex) {
        selectWorld(arcWorld.get(_nIndex));
    }
}
