package Cannon;

import java.awt.image.BufferedImage;
import java.io.File;
import java.util.ArrayList;
import javax.imageio.ImageIO;
//Contains all information from a world or .env file. Includes boss(es), bg, wind, mario, etc.
public class World {

    private ArrayList<Boss> arcBoss=new ArrayList<Boss>();
    private BufferedImage bufImgBg;
    private double dGravity, dWind;
    private String sPath;
    private Mario mario;

    World(ArrayList _boss, BufferedImage _bufImgBg, double _dGravity, double _dWind, String _sPath, Mario _mario) {
        arcBoss=_boss;
        bufImgBg = _bufImgBg;
        dGravity = _dGravity;
        dWind = _dWind;
        sPath=_sPath;
        mario=_mario;
    }
    public void addBoss(Boss _boss) {
        arcBoss.add(_boss);
    }
    public Boss getBoss(int _nBossIndex) {
        return arcBoss.get(_nBossIndex);
    }
    public int getBossX(int _nBossIndex) {
        return arcBoss.get(_nBossIndex).getX();
    }

    public int getBossY(int _nBossIndex) {
        return arcBoss.get(_nBossIndex).getY();
    }

    public int getBossWidth(int _nBossIndex) {
        return arcBoss.get(_nBossIndex).getWidth();
    }

    public int getBossHeight(int _nBossIndex) {
        return arcBoss.get(_nBossIndex).getHeight();
    }

    public int getBossHealth(int _nBossIndex) {
        return arcBoss.get(_nBossIndex).getHealth();
    }
    public int getBossPoints(int _nBossIndex) {
        return arcBoss.get(_nBossIndex).getPoints();
    }
    public int getBossQuan() {
        return arcBoss.size();
    }
    public BufferedImage getBackground() {
        return bufImgBg;
    }
    public double getGravity() {
        return dGravity;
    }
        public Mario getMario() {
        return mario;
    }

    public int getMarioX() {
        return mario.getX();
    }

    public int getMarioY() {
        return mario.getY();
    }

    public int getMarioWidth() {
        return mario.getWidth();
    }

    public int getMarioHeight() {
        return mario.getHeight();
    }
    public String getPath() {
        return sPath;
    }
    public double getWind() {
        return dWind;
    }
    public void setBackground(String sFile) {
        try {
            bufImgBg = ImageIO.read(new File(sFile));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setBackground(BufferedImage _Background) {
        bufImgBg = _Background;
    }

    public void setBoss(Boss _boss) {
        arcBoss.clear();
        arcBoss.add(_boss);
    }
    public void setGravity(double _dGravity) {
        dGravity= _dGravity;
    }
//    public void setPath(String _sPath) {
//        sPath= _sPath;
//    }
    public void setMario(Mario _mario) {
        mario = _mario;
    }

    public void setMarioX(int _nX) {
        mario.setX(_nX);
    }

    public void setMarioY(int _nY) {
        mario.setY(_nY);
    }

    public void setMarioImage(BufferedImage _bufImg) {
        mario.setImage(_bufImg);
    }

    public void setMarioImage(String sMarioLocation) {
        mario.setImage(sMarioLocation);
    }
    public void setWind(double _dWind) {
        dWind=_dWind;
    }
}
